## org.gnu.gtk
Class ScrolledWindow

    java.lang.Object
      org.gnu.glib.GObject
          org.gnu.gtk.GtkObject
              org.gnu.gtk.Widget
                  org.gnu.gtk.Container
                      org.gnu.gtk.Bin
                          org.gnu.gtk.ScrolledWindow

public class ScrolledWindow
extends Bin

A ScrolledWindow is a Bin subclass; it's a container that accepts a single child widget. ScrolledWindow adds scrollbars to the child widget and optionally draws a beveled frame around the child widget.

The ScrolledWindow works in two ways. Some Widgets have native scrolling support; these widgets have "slots" for `Adjustment` objects.

For Widgets that lack native scrolling support the `Viewport` Widget acts as an adaptor class, implementing scrollability for child Widgets that lack their own scrolling capability.

If a Widget has native scrolling capabilities it can be added with the `add` method. If a Widget does not, you must first add the Widget to a `Viewport` and then add the `Viewport` to the ScrolledWindow. The convenience method `addWithViewport` does exactly this, so you can ignore the presence of the `Viewport`.

The position of the scrollbars is controlled by the scroll adjustments. See `Adjustment` for details on how to determine the position of the layout.

Field Summary

Fields inherited from class org.gnu.glib.GObject
`eventsInitialized`

Constructor Summary
`ScrolledWindow()` Creates a new ScrolledWindow object.
`ScrolledWindow(Adjustment hadj, Adjustment vadj)` Create a new ScrolledWindow object.
`ScrolledWindow(Handle handle)` Construct a ScrolledWindow using a handle to a native resource.

Method Summary
`void` `addWithViewport(Widget child)` Used to add children without native scrolling capability.
`Adjustment` `getHAdjustment()` Returns the horizontal Scrollbar's Adjustment.
`static Type` `getType()` Retrieve the runtime type used by the GLib library.
`Adjustment` `getVAdjustment()` Returns the vertical Scrollbar's Adjustment.
`protected static void` `gtk_scrolled_window_add_with_viewport(Handle scrolled_window, Handle child)`
`protected static Handle` `gtk_scrolled_window_get_hadjustment(Handle scrolled_window)`
`protected static int` `gtk_scrolled_window_get_placement(Handle scrolled_window)`
`protected static void` `gtk_scrolled_window_get_policy(Handle scrolled_window, int[] hscrollbarPolicy, int[] vscrollbarPolicy)`
`protected static int` `gtk_scrolled_window_get_shadow_type(Handle scrolled_window)`
`protected static int` `gtk_scrolled_window_get_type()`
`protected static Handle` `gtk_scrolled_window_get_vadjustment(Handle scrolled_window)`
`protected static Handle` `gtk_scrolled_window_new(Handle hadjustment, Handle vadjustment)`
`protected static void` `gtk_scrolled_window_set_hadjustment(Handle scrolled_window, Handle hadjustment)`
`protected static void` `gtk_scrolled_window_set_placement(Handle scrolled_window, int windowPlacement)`
`protected static void` `gtk_scrolled_window_set_policy(Handle scrolled_window, int hscrollbarPolicy, int vscrollbarPolicy)`
`protected static void` `gtk_scrolled_window_set_shadow_type(Handle scrolled_window, int type)`
`protected static void` `gtk_scrolled_window_set_vadjustment(Handle scrolled_window, Handle vadjustment)`
`void` `setHAdjustment(Adjustment hadj)` Sets the horizontal Scrollbar's Adjustment.
`void` `setPlacement(CornerType windowPlacement)` Determines the location of the child widget with respect to the scrollbars.
`void` `setPolicy(PolicyType hScrollBarPolicy, PolicyType vScrollBarPolicy)` Sets the scrollbar policy for the horizontal and vertical scrollbars.
`void` `setShadowType(ShadowType type)` Changes the type of shadow drawn around the contents of the ScrolledWindow.
`void` `setVAdjustment(Adjustment vadj)` Sets the vertical Scrollbar's Adjustment.

Methods inherited from class org.gnu.gtk.Bin
`getChild, gtk_bin_get_child, gtk_bin_get_type`

Methods inherited from class org.gnu.gtk.Container

`add, addListener, fireContainerEvent, getBorderWidth, getChildren, getEventListenerClass, getEventType, getResizeMode, gtk_container_add, gtk_container_check_resize, gtk_container_child_type, gtk_container_get_border_width, gtk_container_get_children, gtk_container_get_focus_chain, gtk_container_get_focus_hadjustment, gtk_container_get_focus_vadjustment, gtk_container_get_resize_mode, gtk_container_get_type, gtk_container_propagate_expose, gtk_container_remove, gtk_container_resize_children, gtk_container_set_border_width, gtk_container_set_focus_chain, gtk_container_set_focus_child, gtk_container_set_focus_hadjustment, gtk_container_set_focus_vadjustment, gtk_container_set_reallocate_redraws, gtk_container_set_resize_mode, gtk_container_unset_focus_chain, remove, removeListener, resizeChildren, setBorderWidth, setResizeMode`

Methods inherited from class org.gnu.gtk.Widget

`activate, addListener, addListener, addListener, addListener, addListener, addListener, addListener, addListener, canActivateAccel, createContext, createLayout, destroy, draw, drawArea, drawArea, findListener, finish, fireBooleanLifeCycleEvent, fireDragDestinationEvent, fireDragSourceEvent, fireExposeEvent, fireFocusEvent, fireKeyEvent, fireLifeCycleEvent, fireMouseEvent, fireMouseMotionEvent, getAccessible, getColormap, getContext, getData, getDisplay, getModifierStyle, getName, getParent, getParentWindow, getPointer, getRootWindow, getScreen, getSensitive, getStyle, getToplevel, getWindow, grabDefault, grabFocus, gtk_drag_dest_set, gtk_drag_dest_unset, gtk_drag_finish, gtk_drag_get_data, gtk_drag_highlight, gtk_drag_source_set_icon_pixbuf, gtk_drag_source_set_icon_stock, gtk_drag_source_set_icon, gtk_drag_source_set, gtk_drag_source_unset, gtk_drag_unhighlight, gtk_widget_activate, gtk_widget_add_accelerator, gtk_widget_add_events, gtk_widget_add_mnemonic_label, gtk_widget_can_activate_accel, gtk_widget_child_focus, gtk_widget_child_notify, gtk_widget_class_path, gtk_widget_create_pango_context, gtk_widget_create_pango_layout, gtk_widget_destroy, gtk_widget_destroyed, gtk_widget_ensure_style, gtk_widget_event, gtk_widget_freeze_child_notify, gtk_widget_get_accessible, gtk_widget_get_ancestor, gtk_widget_get_child_requisition, gtk_widget_get_child_visible, gtk_widget_get_colormap, gtk_widget_get_composite_name, gtk_widget_get_default_colormap, gtk_widget_get_default_direction, gtk_widget_get_default_style, gtk_widget_get_default_visual, gtk_widget_get_direction, gtk_widget_get_display, gtk_widget_get_events, gtk_widget_get_extension_events, gtk_widget_get_modifier_style, gtk_widget_get_name, gtk_widget_get_pango_context, gtk_widget_get_parent_window, gtk_widget_get_parent, gtk_widget_get_pointer, gtk_widget_get_root_window, gtk_widget_get_screen, gtk_widget_get_sensitive, gtk_widget_get_settings, gtk_widget_get_size_request, gtk_widget_get_style, gtk_widget_get_toplevel, gtk_widget_get_type, gtk_widget_get_visual, gtk_widget_get_window, gtk_widget_grab_default, gtk_widget_grab_focus, gtk_widget_has_screen, gtk_widget_hide_all, gtk_widget_hide_on_delete, gtk_widget_hide, gtk_widget_intersect, gtk_widget_is_ancestor, gtk_widget_is_focus, gtk_widget_list_accel_closures, gtk_widget_list_mnemonic_labels, gtk_widget_map, gtk_widget_mnemonic_activate, gtk_widget_modify_base, gtk_widget_modify_bg, gtk_widget_modify_fg, gtk_widget_modify_font, gtk_widget_modify_style, gtk_widget_modify_text, gtk_widget_path, gtk_widget_pop_colormap, gtk_widget_pop_composite_child, gtk_widget_push_colormap, gtk_widget_push_composite_child, gtk_widget_queue_draw_area, gtk_widget_queue_draw, gtk_widget_queue_resize, gtk_widget_realize, gtk_widget_ref, gtk_widget_region_intersect, gtk_widget_remove_accelerator, gtk_widget_remove_mnemonic_label, gtk_widget_render_icon, gtk_widget_reparent, gtk_widget_reset_rc_styles, gtk_widget_send_expose, gtk_widget_set_accel_path, gtk_widget_set_app_paintable, gtk_widget_set_child_visible, gtk_widget_set_colormap, gtk_widget_set_composite_name, gtk_widget_set_default_colormap, gtk_widget_set_default_direction, gtk_widget_set_direction, gtk_widget_set_double_buffered, gtk_widget_set_events, gtk_widget_set_extension_events, gtk_widget_set_name, gtk_widget_set_parent_window, gtk_widget_set_parent, gtk_widget_set_redraw_on_allocate, gtk_widget_set_scroll_adjustments, gtk_widget_set_sensitive, gtk_widget_set_size_request, gtk_widget_set_state, gtk_widget_set_style, gtk_widget_shape_combine_mask, gtk_widget_show_all, gtk_widget_show_now, gtk_widget_show, gtk_widget_size_allocate, gtk_widget_size_request, gtk_widget_style_get_property, gtk_widget_thaw_child_notify, gtk_widget_translate_coordinates, gtk_widget_unmap, gtk_widget_unparent, gtk_widget_unrealize, gtk_widget_unref, handleButtonPressed, handleButtonReleased, handleDelete, handleDragDataGet, handleDragDestination, handleExpose, handleFocusIn, handleFocusOut, handleHide, handleKeyPressed, handleKeyReleased, handleMap, handleMouseEnter, handleMouseLeave, handleMouseMotion, handleNoExpose, handleRealize, handleScroll, handleShow, handleUnmap, hasFocus, hasScreen, hide, hideAll, highlight, intersect, isAncestor, makeWidget, modifyStyle, popColormap, pushColormap, realize, removeListener, removeListener, removeListener, removeListener, removeListener, removeListener, removeListener, removeListener, reparent, setBackgroundColor, setBaseColor, setColormap, setDoubleBuffered, setDragDestination, setDragIcon, setDragIconPixbuf, setDragIconStock, setDragSource, setFont, setForegroundColor, setMinimumSize, setName, setNoDragDestination, setNoDragSource, setSensitive, setTextColor, shapeCombineMask, show, showAll, unHighlight`

Methods inherited from class org.gnu.gtk.GtkObject
`getFlags, gtk_object_destroy, gtk_object_get_type, gtk_object_sink, setFlags, sink`

Methods inherited from class org.gnu.glib.GObject

`addEventHandler, addEventHandler, addEventHandler, addEventHandler, addEventHandler, addEventHandler, addListener, equals, freezeNotify, getBooleanProperty, getData, getData, getDoubleProperty, getFloatProperty, getGObjectFromHandle, getHandle, getIntFromHandle, getIntProperty, getJavaObjectProperty, getLongProperty, getNullHandle, getPixbufProperty, getProperty, getStringFromHandle, getStringProperty, hashCode, hasProperty, instantiateJGObjectFromGType, notify, removeEventHandler, removeListener, retrieveGObject, setBooleanProperty, setData, setData, setDoubleProperty, setFloatProperty, setHandle, setIntProperty, setJavaObjectProperty, setLongProperty, setPixbufProperty, setProperty, setStringProperty, thawNotify`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### ScrolledWindow

    public ScrolledWindow(Adjustment hadj,
                          Adjustment vadj)

  Create a new ScrolledWindow object. The two arguments are the ScrolledWindow's `Adjustments`; these will be shared with the scrollbars and the child widgets to keep the bars in sync with the child.

Parameters:
  `hadj` - The horizontal Adjustment.
  `vadj` - The vertical Adjustment.

### ScrolledWindow

    public ScrolledWindow()

  Creates a new ScrolledWindow object. This constuctor generates `Adjustment`s automatically.

### ScrolledWindow

    public ScrolledWindow(Handle handle)

  Construct a ScrolledWindow using a handle to a native resource.

Method Detail

### getHAdjustment

    public Adjustment getHAdjustment()

  Returns the horizontal Scrollbar's Adjustment. This can be used to connect the horizontal Scrollbar to the child Widget's horizontal scroll functionality.

  Returns:
    The horizontal Scrollbar's Adjustment.

### setHAdjustment

    public void setHAdjustment(Adjustment hadj)

  Sets the horizontal Scrollbar's Adjustment.

  Parameters:
    `hadj` - The horizontal Adjustment.

### getVAdjustment

    public Adjustment getVAdjustment()

  Returns the vertical Scrollbar's Adjustment. This can be used to connect the vertical Scrollbar to the child Widget's vertical scroll functionality.

  Returns:
    The vertical Scrollbar's Adjustment.

### setVAdjustment

    public void setVAdjustment(Adjustment vadj)

  Sets the vertical Scrollbar's Adjustment.

  Parameters:
    `vadj` - The vertical Adjustment.

### setPolicy

    public void setPolicy(PolicyType hScrollBarPolicy,
                          PolicyType vScrollBarPolicy)

  Sets the scrollbar policy for the horizontal and vertical scrollbars. The policy determines when the scrollbar should appear.

  Parameters:
    `hScrollBarPolicy` - The policy for the horizontal ScrollBar.
    `vScrollBarPolicy` - The policy for the vertical ScrollBar.

### addWithViewport

    public void addWithViewport(Widget child)

  Used to add children without native scrolling capability. This is simply a convenience method, it is equivalent to adding the unscrollable child to a Viewport, then adding the Viewport to the ScrolledWindow.

  Parameters:
    `child` - The Widget to add to the ScrolledWindow.

### setPlacement

    public void setPlacement(CornerType windowPlacement)

  Determines the location of the child widget with respect to the scrollbars. The default is CORNER_TOP_LEFT, meaning the child is in the top left, with the scrollbar underneath and to the right.

  Parameters:
    `windowPlacement` - The placement for the child widget.

### setShadowType

    public void setShadowType(ShadowType type)

  Changes the type of shadow drawn around the contents of the ScrolledWindow.

  Parameters:
    `type` - The type of shadow to draw.

### getType

    public static Type getType()

  Retrieve the runtime type used by the GLib library.

### gtk_scrolled_window_get_type

    protected static final int gtk_scrolled_window_get_type()

### gtk_scrolled_window_new

    protected static final Handle gtk_scrolled_window_new(Handle hadjustment,
                                                          Handle vadjustment)

### gtk_scrolled_window_set_hadjustment

    protected static final void gtk_scrolled_window_set_hadjustment(Handle scrolled_window,
                                                                    Handle hadjustment)

### gtk_scrolled_window_set_vadjustment

    protected static final void gtk_scrolled_window_set_vadjustment(Handle scrolled_window,
                                                                    Handle vadjustment)

### gtk_scrolled_window_get_hadjustment

    protected static final Handle gtk_scrolled_window_get_hadjustment(Handle scrolled_window)

### gtk_scrolled_window_get_vadjustment

    protected static final Handle gtk_scrolled_window_get_vadjustment(Handle scrolled_window)

### gtk_scrolled_window_set_policy

    protected static final void gtk_scrolled_window_set_policy(Handle scrolled_window,
                                                               int hscrollbarPolicy,
                                                               int vscrollbarPolicy)

### gtk_scrolled_window_get_policy

    protected static final void gtk_scrolled_window_get_policy(Handle scrolled_window,
                                                               int[] hscrollbarPolicy,
                                                               int[] vscrollbarPolicy)

### gtk_scrolled_window_set_placement

    protected static final void gtk_scrolled_window_set_placement(Handle scrolled_window,
                                                                  int windowPlacement)

### gtk_scrolled_window_get_placement

    protected static final int gtk_scrolled_window_get_placement(Handle scrolled_window)

### gtk_scrolled_window_set_shadow_type

    protected static final void gtk_scrolled_window_set_shadow_type(Handle scrolled_window,
                                                                    int type)

### gtk_scrolled_window_get_shadow_type

    protected static final int gtk_scrolled_window_get_shadow_type(Handle scrolled_window)

### gtk_scrolled_window_add_with_viewport

    protected static final void gtk_scrolled_window_add_with_viewport(Handle scrolled_window,
                                                                      Handle child)